;include	'../include/elf64.inc'

align 16
init_symbols:
; in:		rax	pointer to the filename
; action:	fills buffers with symbol table and string table
; destroys:	nonvolatile registers

	push	rbx rbp r12 r13 r14 r15

virtual at 0
Elf64FileHeader		Elf64_Ehdr
sizeof_Elf64_Ehdr	=	$
end virtual

virtual at 0
Elf64SectionHeader	Elf64_Shdr
sizeof_Elf64_Shdr	=	$
end virtual

virtual at 0
Elf64SymbolEntry	Elf64_Sym
sizeof_Elf64SymbolEntry	=	$
end virtual

	xor	esi,esi
	lea	rdi,[rax]
	mov	eax,sys_open
	syscall
	or	rax,rax
	js	init_symbols_fail

	mov	rbx,rax

	xor	r9,r9			; offset
					; PAGESIZE=1000h maping file at offset 0
					; is allowed
	mov	r8,rbx			; fd
	mov	r10d,MAP_PRIVATE	; flags
	mov	edx,PROT_READ		; prot
	mov	esi,sizeof_Elf64_Ehdr	; lenght
	xor	edi,edi			; start
	mov	eax,sys_mmap
	syscall
	or	rax,rax
	js	init_symbols_fail

	cmp	dword [rax],ELFMAG
	jnz	init_symbols_fail
	cmp	byte [rax+EI_CLASS],ELFCLASS64
	jnz	init_symbols_fail
	cmp	byte [rax+EI_DATA],ELFDATA2LSB
	jnz	init_symbols_fail

	cmp	[rax+Elf64FileHeader.e_type],ET_EXEC
	jnz	init_symbols_fail
	cmp	[rax+Elf64FileHeader.e_machine],EM_X8664
	jnz	init_symbols_fail
	cmp	[rax+Elf64FileHeader.e_ehsize],sizeof_Elf64_Ehdr
	jnz	init_symbols_fail
	cmp	[rax+Elf64FileHeader.e_shentsize],sizeof_Elf64_Shdr
	jnz	init_symbols_fail

	mov	r15,[rax+Elf64FileHeader.e_shoff]
	or	r15,r15			; empty ?
	jz	init_symbols_fail
	movzx	ebp,[rax+Elf64FileHeader.e_shnum]
	or	ebp,ebp
	jz	init_symbols_fail

	mov	esi,sizeof_Elf64_Ehdr	; lenght
	lea	rdi,[rax]		; start
	mov	eax,sys_munmap
	syscall
	or	rax,rax
	js	init_symbols_fail

	xor	r9,r9			; offset
	xor	r8,r8			; fd
	mov	r10d,MAP_PRIVATE or MAP_ANONYMOUS	; flags
	mov	edx,PROT_READ or PROT_WRITE	; prot

if sizeof_Elf64_Shdr = 40h
	lea	eax,[rbp*8]
	lea	esi,[rax*8]		; lenght = sizeof_Elf64_Shdr*e_shnum
else
Make another procedure to calculate appropriate size!
end if

	mov	[SymbolTableSize],rsi	; not really SymbolTbl, we use it temporary
	xor	edi,edi			; start
	mov	eax,sys_mmap
	syscall
	or	rax,rax
	js	init_symbols_fail

	mov	[SymbolTable],rax	; not really SymTbl, we use it temporary

	mov	r10,r15
	mov	rdx,[SymbolTableSize]
	lea	rsi,[rax]
	mov	rdi,rbx
	mov	eax,sys_pread64
	syscall
	or	rax,rax
	js	init_symbols_fail
	cmp	[SymbolTableSize],rax
	jnz	init_symbols_fail

; find symbol table
	mov	rsi,[SymbolTable]
	lea	rcx,[rsi]

sym_tbl_scan:
	cmp	[rsi+Elf64SectionHeader.sh_type],SHT_SYMTAB
	jz	sym_tbl_have_it
;sym_tbl_next:
	add	rsi,sizeof_Elf64_Shdr
	dec	ebp
	jnz	sym_tbl_scan
	jmp	init_symbols_fail

sym_tbl_have_it:
	mov	r15,[rsi+Elf64SectionHeader.sh_offset]
	mov	r14,[rsi+Elf64SectionHeader.sh_size]
	or	r15,r15
	jz	init_symbols_fail
	or	r14,r14
	jz	init_symbols_fail

; find string table used by entries in this section
	mov	eax,[rsi+Elf64SectionHeader.sh_link]
	or	eax,eax
	jz	init_symbols_fail

if sizeof_Elf64_Shdr = 40h ; 40h=64=8*8
	lea	rax,[rax*8]		; yeah lea eax,[rax*8] is 1 byte smaller
	mov	r13,[rcx+rax*8+Elf64SectionHeader.sh_offset]
	mov	r12,[rcx+rax*8+Elf64SectionHeader.sh_size]
else
Make another procedure to calculate appropriate size!
end if

	or	r13,r13
	jz	init_symbols_fail
	or	r12,r12
	jz	init_symbols_fail

; now we unmap memory
	mov	rsi,[SymbolTableSize]	; not really SymTbl, used temporary only
	mov	rdi,[SymbolTable]	; not really SymTbl, used temporary only
	mov	eax,sys_munmap
	syscall
	or	rax,rax
	js	init_symbols_fail

; read Symbol Table
	xor	r9,r9			; offset
	xor	r8,r8			; fd
	mov	r10d,MAP_PRIVATE or MAP_ANONYMOUS	; flags
	mov	edx,PROT_READ or PROT_WRITE	; prot
	mov	rsi,r14			; lenght
	xor	edi,edi			; start
	mov	eax,sys_mmap
	syscall
	or	rax,rax
	js	init_symbols_fail
	mov	[SymbolTable],rax

	mov	r10,r15
	mov	rdx,r14
	lea	rsi,[rax]
	mov	rdi,rbx
	mov	eax,sys_pread64
	syscall
	or	rax,rax
	js	init_symbols_fail
	cmp	r14,rax
	jnz	init_symbols_fail
	mov	[SymbolTableSize],rax

; String Table
	xor	r9,r9			; offset
	xor	r8,r8			; fd
	mov	r10d,MAP_PRIVATE or MAP_ANONYMOUS	; flags
	mov	edx,PROT_READ or PROT_WRITE	; prot
	mov	rsi,r12			; lenght
	xor	edi,edi			; start
	mov	eax,sys_mmap
	syscall
	or	rax,rax
	js	init_symbols_fail
	mov	[StringTable],rax

	mov	r10,r13
	mov	rdx,r12
	lea	rsi,[rax]
	mov	rdi,rbx
	mov	eax,sys_pread64
	syscall
	or	rax,rax
	js	init_symbols_fail
	cmp	r12,rax
	jnz	init_symbols_fail
	mov	[StringTableSize],rax

	mov	rdi,rbx
	mov	eax,sys_close
	syscall

init_symbols_done:
	clc
init_symbols_epi:
	pop	r15 r14 r13 r12 rbp rbx
	ret

init_symbols_fail:
	stc
	xor	eax,eax
	mov	[SymbolTable],rax
	mov	[SymbolTableSize],rax
	mov	[StringTable],rax
	mov	[StringTableSize],rax
	jmp	init_symbols_epi

; -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
align 16
addr2symbol:
; in:	rax	address
; 	rdi	pointer to store the the name of the symbol
; out:	CF=0	success
;		RDI+sizeof_symbol
;	CF=1	no such symbol name
	push	rax rcx rdx rbx rsi

	mov	rdx,[SymbolTable]
	mov	rcx,[SymbolTableSize]

	or	rdx,rdx
	jz	addr2symbol_failed
;	or	rcx,rcx
;	jz	addr2symbol_failed
	jrcxz	addr2symbol_failed

addr2symbol_scan:
	cmp	[rdx+Elf64SymbolEntry.st_value],rax
	jnz	addr2symbol_scan_next

; we have STB_... values in form 00h, 10h, 20h, so we use trick:
	cmp	[rdx+Elf64SymbolEntry.st_info],STB_GLOBAL
; this is correct but longer way:
;	mov	reg8,[]
;	and	reg8,11110000b ; shl reg8,4 may be used too
;	cmp	reg8,...
	jnc	addr2symbol_translate	; skip STB_LOCAL entries
addr2symbol_scan_next:
	add	rdx,sizeof_Elf64SymbolEntry
	sub	rcx,sizeof_Elf64SymbolEntry
	jnbe	addr2symbol_scan

addr2symbol_failed:
	stc
	jmp	addr2symbol_epi

addr2symbol_translate:
	mov	eax,[rdx+Elf64SymbolEntry.st_name]

	mov	rdx,[StringTable]
	mov	rcx,[StringTableSize]
	or	rdx,rdx
	jz	addr2symbol_failed
;	or	rcx,rcx
;	jz	addr2symbol_failed
	jrcxz	addr2symbol_failed

	sub	rcx,rax
	jbe	addr2symbol_failed

	lea	rsi,[rdi]		; save rdi
	lea	rdi,[rdx+rax*1]
	lea	ebx,[rcx-1]		; exclude 0-terminator
	xor	eax,eax
	push	rdi
	repnz scasb
	pop	rdi
	sub	ebx,ecx
	jz	addr2symbol_failed

	xchg	rsi,rdi
	mov	ecx,ebx
	repz movsb
	mov	byte [rdi],0		; 0-terminator

	clc
addr2symbol_epi:
	pop	rsi rbx rdx rcx rax
	ret

; -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
align 16
addr2symbol_proximus:
; in:	rax	address
; 	rdi	pointer to store the the name of the symbol
; out:	CF=0	success
;		RDI+sizeof_symbol
;	CF=1	no such symbol name
; the difference is that we store +delta after the name of the symbol, e.g.
; in:	rax=100000090
; out:	start (the same as addr2symbol)
; in:	rax=1000000A4
; out:	start+0000000000000014
	push	rax rcx rdx rbx rbp rsi

	mov	rdx,[SymbolTable]
	mov	rcx,[SymbolTableSize]

	or	rdx,rdx
	jz	addr2symbol_proximus_failed
;	or	rcx,rcx
;	jz	addr2symbol_proximus_failed
	jrcxz	addr2symbol_proximus_failed

	xor	ebp,ebp
addr2symbol_proximus_scan:
	mov	rsi,[rdx+Elf64SymbolEntry.st_value]
; take only symbol with address less or equal rax, else discard
	cmp	rax,rsi
	jc	addr2symbol_proximus_scan_next

; we have STB_... values in form 00h, 10h, 20h, so we use trick:
	cmp	[rdx+Elf64SymbolEntry.st_info],STB_GLOBAL
; this is correct but longer way:
;	mov	reg8,[]
;	and	reg8,11110000b ; shl reg8,4 may be used too
;	cmp	reg8,...
	jc	addr2symbol_proximus_scan_next	; skip STB_LOCAL entries

; choose the biggest address (thus closest to rax)
	cmp	rbp,rsi
	cmovc	rbp,rsi
	cmovc	rbx,rdx
addr2symbol_proximus_scan_next:
	add	rdx,sizeof_Elf64SymbolEntry
	sub	rcx,sizeof_Elf64SymbolEntry
	jnbe	addr2symbol_proximus_scan
	or	rbp,rbp
	jnz	addr2symbol_proximus_translate

addr2symbol_proximus_failed:
	stc
	jmp	addr2symbol_proximus_epi

addr2symbol_proximus_translate:
; difference between the address requested and the address of the symbol
	sub	rax,rbp
	xchg	rbp,rax

	mov	eax,[rbx+Elf64SymbolEntry.st_name]

	mov	rdx,[StringTable]
	mov	rcx,[StringTableSize]
	or	rdx,rdx
	jz	addr2symbol_proximus_failed
;	or	rcx,rcx
;	jz	addr2symbol_proximus_failed
	jrcxz	addr2symbol_proximus_failed

	sub	rcx,rax
	jbe	addr2symbol_proximus_failed

	lea	rsi,[rdi]		; save rdi
	lea	rdi,[rdx+rax*1]
	lea	ebx,[rcx-1]		; exclude 0-terminator
	xor	eax,eax
	push	rdi
	repnz scasb
	pop	rdi
	sub	ebx,ecx
	jz	addr2symbol_failed

	xchg	rsi,rdi
	mov	ecx,ebx
	repz movsb

	or	rbp,rbp
	jz	addr2symbol_proximus_success

	mov	al,'+'
	stosb
	xchg	rbp,rax
	call	hexa_64_rax
	lea	rdi,[rdi+16]

addr2symbol_proximus_success:
	mov	byte [rdi],0		; 0-terminator
	clc
addr2symbol_proximus_epi:
	pop	rsi rbp rbx rdx rcx rax
	ret

; -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
align 16
symbol2addr:
; in:	rsi	pointer to the name of the symbol
;	eax	size of the name
; out:	CF=0	success
;		RAX address
;		RSI+sizeof_symbol
;	CF=1	no such symbol name
;		RAX=0
	push	rcx rdx rbx rbp rdi r8 r9 r10

	mov	rdx,[SymbolTable]
	mov	r9,[SymbolTableSize]
	mov	rbx,[StringTable]
	mov	r8,[StringTableSize]
	or	rdx,rdx
	jz	symbol2addr_failed
	or	r9,r9
	jz	symbol2addr_failed
	or	rbx,rbx
	jz	symbol2addr_failed
	or	r8,r8
	jz	symbol2addr_failed

	or	eax,eax			; check empty string (only 0-terminator)
	jz	symbol2addr_failed
	mov	ebp,eax			; size of symbol to search

symbol2addr_scan:
	mov	eax,[rdx+Elf64SymbolEntry.st_name]
; this makes routine faster, but consumes bytes:
;	or	eax,eax
;	jz	symbol2addr_next

	lea	rdi,[rbx+rax*1]
	mov	ecx,r8d
	sub	ecx,eax
	jbe	symbol2addr_failed
	lea	r10,[rdi+rbp*1+1]	; +1 include 0-terminator
	xor	eax,eax
	push	rdi
	repnz scasb
	cmp	rdi,r10
	pop	rdi
	jnz	symbol2addr_next

	push	rsi
	mov	ecx,ebp
	repz cmpsb
	pop	rsi
	jz	symbol2addr_done

symbol2addr_next:
	add	rdx,sizeof_Elf64SymbolEntry
	sub	r9,sizeof_Elf64SymbolEntry
	jnbe	symbol2addr_scan

symbol2addr_failed:
	xor	eax,eax
	stc
	jmp	symbol2addr_epi

symbol2addr_done:
	add	rsi,rbp
	mov	rax,[rdx+Elf64SymbolEntry.st_value]

	clc
symbol2addr_epi:
	pop	r10 r9 r8 rdi rbp rbx rdx rcx
	ret

align 16
symbol_with_delta2addr:
; in:	rsi	pointer to the name of the symbol
;		the whole string is terminated with byte < 20h
;		string mustn't contain space (20h)
;		examples:
;		proc_encrypt_file	; begin of the procedure
;		proc_decrypt_file+14E	; 14E bytes forward proc_...
;		hash_value-C		; 12 bytes backward of hash_value
; out:	CF=0	success
;		RAX address
;		RSI+sizeof_symbol
;	CF=1	no such symbol name
;		RAX=0
	push	rbx rdx rsi rax
	lea	rax,[rsi]
	jmp	symbol_with_delta2addr_L0_check

AMDPad16
symbol_with_delta2addr_L0:
	inc	rax
symbol_with_delta2addr_L0_check:
	cmp	byte [rax],'+'
	jz	symbol_with_delta2addr_L1
	cmp	byte [rax],'-'
	jz	symbol_with_delta2addr_L1
	cmp	byte [rax],']'
	jz	symbol_with_delta2addr_L1
	cmp	byte [rax],20h
	jnc	symbol_with_delta2addr_L0
symbol_with_delta2addr_L1:
	sub	rax,rsi
;	jz	symbol_with_delta2addr_failed	; following proc checks eax=0
	call	symbol2addr
	jc	symbol_with_delta2addr_failed
;	mov	qword [rsp],rax
; this is smaller:
	pop	rdx
	push	rax

	xor	edx,edx		; prepare for jc symbol_with_delta2addr_done
	cmp	byte [rsi],']'
	jz	symbol_with_delta2addr_done
	cmp	byte [rsi],20h
	jc	symbol_with_delta2addr_done
	lodsb
	cmp	al,'+'
	jz	symbol_with_delta2addr_OK
	cmp	al,'-'
	jnz	symbol_with_delta2addr_failed
symbol_with_delta2addr_OK:
	xchg	ebx,eax				; put + or - into bl
	lea	rax,[rsi]
	jmp	symbol_with_delta2addr_L2_check
AMDPad16
symbol_with_delta2addr_L2:
	inc	rax
symbol_with_delta2addr_L2_check:
	cmp	byte [rax],']'
	jz	symbol_with_delta2addr_L3
	cmp	byte [rax],20h
	jnbe	symbol_with_delta2addr_L2
symbol_with_delta2addr_L3:
	sub	rax,rsi
;	jz	symbol_with_delta2addr_failed	; following proc checks rax=0
	call	ascii2hexa_qword
	jc	symbol_with_delta2addr_failed
	mov	rax,rdx
	neg	rax
	cmp	bl,'-'
	cmovz	rdx,rax
symbol_with_delta2addr_done:
	pop	rax
	add	rax,rdx
	pop	rdx		; pop original rsi, we update rsi if success
	pop	rdx		; pop original rdx
	pop	rbx
	clc			; must be here - jbe symbol_with_delta2addr_done
	ret

symbol_with_delta2addr_failed:
	pop	rax rsi rdx rbx
	xor	eax,eax
	stc
	ret
