; 64-bit ELF base types.
Elf64_Addr		equ	rq	1
Elf64_Half		equ	rw	1
Elf64_SHalf		equ	rw	1
Elf64_Off		equ	rq	1
Elf64_Sword		equ	rd	1
Elf64_Word		equ	rd	1
Elf64_Xword		equ	rq	1
Elf64_Sxword		equ	rq	1
unsigned_char		equ	rb	1

; These constants are for the segment types stored in the image headers
PT_NULL			=	0
PT_LOAD			=	1
PT_DYNAMIC		=	2
PT_INTERP		=	3
PT_NOTE			=	4
PT_SHLIB		=	5
PT_PHDR			=	6
PT_LOPROC		=	70000000h
PT_HIPROC		=	7fffffffh
PT_MIPS_REGINFO		=	70000000h

; Flags in the e_flags field of the header
EF_MIPS_NOREORDER	=	00000001h
EF_MIPS_PIC		=	00000002h
EF_MIPS_CPIC		=	00000004h
EF_MIPS_ARCH		=	0f0000000h

; These constants define the different elf file types e_type
ET_NONE			=	0
ET_REL			=	1
ET_EXEC			=	2
ET_DYN			=	3
ET_CORE			=	4
ET_LOPROC		=	0ff00h
ET_HIPROC		=	0ffffh

; These constants define the various ELF target machines
EM_NONE			=	0
EM_M32			=	1
EM_SPARC		=	2
EM_386			=	3
EM_68K			=	4
EM_88K			=	5
EM_486			=	6		; Perhaps disused
EM_860			=	7
EM_MIPS			=	8	; MIPS R3000 (officially, big-endian only)
EM_MIPS_RS4_BE		=	10	; MIPS R4000 big-endian
EM_PARISC		=	15	; HPPA
EM_SPARC32PLUS		=	18	; Sun's "v8plus"
EM_PPC			=	20	; PowerPC
EM_PPC64		=	21	; PowerPC64
EM_SH			=	42	; SuperH
EM_SPARCV9		=	43	; SPARC v9 64-bit
EM_IA_64		=	50	; HP/Intel IA-64
EM_X8664		=	62	; AMD x86-64
EM_S390			=	22	; IBM S/390
EM_CRIS			=	76	; Axis Communications 32-bit embedded processor

; This is an interim value that we will use until the committee comes
; up with a final number.
EM_ALPHA		=	9026h

; This is the old interim value for S/390 architecture
EM_S390_OLD		=	0A390h

; This is the info that is needed to parse the dynamic section of the file
DT_NULL			=	0
DT_NEEDED		=	1
DT_PLTRELSZ		=	2
DT_PLTGOT		=	3
DT_HASH			=	4
DT_STRTAB		=	5
DT_SYMTAB		=	6
DT_RELA			=	7
DT_RELASZ		=	8
DT_RELAENT		=	9
DT_STRSZ		=	10
DT_SYMENT		=	11
DT_INIT			=	12
DT_FINI			=	13
DT_SONAME		=	14
DT_RPATH		=	15
DT_SYMBOLIC		=	16
DT_REL			=	17
DT_RELSZ		=	18
DT_RELENT		=	19
DT_PLTREL		=	20
DT_DEBUG		=	21
DT_TEXTREL		=	22
DT_JMPREL		=	23
DT_LOPROC		=	70000000h
DT_HIPROC		=	7fffffffh
DT_MIPS_RLD_VERSION	=	70000001h
DT_MIPS_TIME_STAMP	=	70000002h
DT_MIPS_ICHECKSUM	=	70000003h
DT_MIPS_IVERSION	=	70000004h
DT_MIPS_FLAGS		=	70000005h
	RHF_NONE	=	0
	RHF_HARDWAY	=	1
	RHF_NOTPOT	=	2
DT_MIPS_BASE_ADDRESS	=	70000006h
DT_MIPS_CONFLICT	=	70000008h
DT_MIPS_LIBLIST		=	70000009h
DT_MIPS_LOCAL_GOTNO	=	7000000ah
DT_MIPS_CONFLICTNO	=	7000000bh
DT_MIPS_LIBLISTNO	=	70000010h
DT_MIPS_SYMTABNO	=	70000011h
DT_MIPS_UNREFEXTNO	=	70000012h
DT_MIPS_GOTSYM		=	70000013h
DT_MIPS_HIPAGENO	=	70000014h
DT_MIPS_RLD_MAP		=	70000016h

; This info is needed when parsing the symbol table
;STB_LOCAL		=	0
;STB_GLOBAL		=	1
;STB_WEAK		=	2
STB_LOCAL		=	0 shl 4
STB_GLOBAL		=	1 shl 4
STB_WEAK		=	2 shl 4

STT_NOTYPE		=	0
STT_OBJECT		=	1
STT_FUNC		=	2
STT_SECTION		=	3
STT_FILE		=	4

;macro	ELF32_ST_BIND value
;{
;	db	value shl 4
;}
;
;macro	ELF32_ST_BIND reg8
;{
;	shl	reg8,4
;}
;
;macro	ELF32_ST_TYPE value
;{
;	db	value and 0Fh
;}
;
;macro	ELF32_ST_TYPE reg8
;{
;	and	reg8,0Fh
;}


;typedef struct {
;  Elf64_Sxword d_tag;		/* entry tag value */
;  union {
;    Elf64_Xword d_val;
;    Elf64_Addr d_ptr;
;  } d_un;
;} Elf64_Dyn;


struc	Elf64_Rel
{
	.r_offset	Elf64_Addr	; Location at which to apply the action
	.r_info		Elf64_Xword	; index and type of relocation
}


struc	Elf64_Rela
{
	.r_offset	Elf64_Addr	; Location at which to apply the action
	.r_info		Elf64_Xword	; index and type of relocation
	.r_addend	Elf64_Sxword	; Constant addend used to compute value
} 


struc	Elf64_Sym
{
	.st_name	Elf64_Word	; Symbol name, index in string tbl
	.st_info	unsigned_char	; Type and binding attributes
	.st_other	unsigned_char	; Reserved, no defined meaning, 0
	.st_shndx	Elf64_Half	; Associated section table index
	.st_value	Elf64_Addr	; Value of the symbol
	.st_size	Elf64_Xword	; Associated symbol size
}


EI_NIDENT	=	16

struc	Elf64_Ehdr
{
	.e_ident	rb EI_NIDENT	; ELF "magic number" + others
	.e_type		Elf64_Half 
	.e_machine	Elf64_Half 
	.e_version	Elf64_Word 
	.e_entry	Elf64_Addr	; Entry point virtual address
	.e_phoff	Elf64_Off	; Program header table file offset
	.e_shoff	Elf64_Off	; Section header table file offset
	.e_flags	Elf64_Word 
	.e_ehsize	Elf64_Half
	.e_phentsize	Elf64_Half
	.e_phnum	Elf64_Half
	.e_shentsize	Elf64_Half
	.e_shnum	Elf64_Half
	.e_shstrndx	Elf64_Half
}


; These constants define the permissions on sections in the program
; header, p_flags.
PF_R		=	4
PF_W		=	2
PF_X		=	1


struc	Elf64_Phdr
{
	.p_type		Elf64_Word
	.p_flags	Elf64_Word
	.p_offset	Elf64_Off	; Segment file offset
	.p_vaddr	Elf64_Addr 	; Segment virtual address
	.p_paddr	Elf64_Addr 	; Segment physical address
	.p_filesz	Elf64_Xword	; Segment size in file
	.p_memsz	Elf64_Xword	; Segment size in memory
	.p_align	Elf64_Xword	; Segment alignment, file & memory
}


; sh_type
SHT_NULL		=	0
SHT_PROGBITS		=	1
SHT_SYMTAB		=	2
SHT_STRTAB		=	3
SHT_RELA		=	4
SHT_HASH		=	5
SHT_DYNAMIC		=	6
SHT_NOTE		=	7
SHT_NOBITS		=	8
SHT_REL			=	9
SHT_SHLIB		=	10
SHT_DYNSYM		=	11
SHT_NUM			=	12
SHT_LOPROC		=	70000000h
SHT_HIPROC		=	7fffffffh
SHT_LOUSER		=	80000000h
SHT_HIUSER		=	0ffffffffh
SHT_MIPS_LIST		=	70000000h
SHT_MIPS_CONFLICT	=	70000002h
SHT_MIPS_GPTAB		=	70000003h
SHT_MIPS_UCODE		=	70000004h

; sh_flags
SHF_WRITE		=	1
SHF_ALLOC		=	2
SHF_EXECINSTR		=	4
SHF_MASKPROC		=	0f0000000h
SHF_MIPS_GPREL		=	10000000h

; special section indexes
SHN_UNDEF		=	0
SHN_LORESERVE		=	0ff00h
SHN_LOPROC		=	0ff00h
SHN_HIPROC		=	0ff1fh
SHN_ABS			=	0fff1h
SHN_COMMON		=	0fff2h
SHN_HIRESERVE		=	0ffffh
SHN_MIPS_ACCOMON	=	0ff00h
 

struc	Elf64_Shdr
{
	.sh_name	Elf64_Word	; Section name, index in string tbl
	.sh_type	Elf64_Word	; Type of section
	.sh_flags	Elf64_Xword	; Miscellaneous section attributes
	.sh_addr	Elf64_Addr	; Section virtual addr at execution
	.sh_offset	Elf64_Off	; Section file offset
	.sh_size	Elf64_Xword	; Size of section in bytes
	.sh_link	Elf64_Word	; Index of another section
	.sh_info	Elf64_Word	; Additional section information
	.sh_addralign	Elf64_Xword	; Section alignment
	.sh_entsize	Elf64_Xword	; Entry size if section holds table
}


;  e_ident[] indexes
EI_MAG0			=	0
EI_MAG1			=	1
EI_MAG2			=	2
EI_MAG3			=	3
EI_CLASS		=	4
EI_DATA			=	5
EI_VERSION		=	6
EI_PAD			=	7

; EI_MAG
ELFMAG0			=	7Fh
ELFMAG1			=	'E'
ELFMAG2			=	'L'
ELFMAG3			=	'F'
ELFMAG			=	7Fh+'ELF'*100h
SELFMAG			=	4
                	
; EI_CLASS      	
ELFCLASSNONE		=	0
ELFCLASS32		=	1
ELFCLASS64		=	2
ELFCLASSNUM		=	3

; e_ident[EI_DATA]
ELFDATANONE		=	0
ELFDATA2LSB		=	1
ELFDATA2MSB		=	2

; e_version, EI_VERSION
EV_NONE			=	0
EV_CURRENT		=	1
EV_NUM			=	2


;/* Note header in a PT_NOTE section */
;typedef struct elf64_note {
;  Elf64_Word n_namesz;	/* Name size */
;  Elf64_Word n_descsz;	/* Content size */
;  Elf64_Word n_type;	/* Content type */
;} Elf64_Nhdr;
