	cmp	eax,1
	jbe	cant_optimize_002_L0

; there is a chain with EAX lenght on RSI
; explore if there isn't any chain with no change delta on RSI - if there is any then use it
	call	scanincd	; include procedure in scan_ncd.inc
	jc	cant_optimize_002_L1
	mov	rbx,[last_delta]
; pack without change delta has superior pack priority ( the best pack ratio )
	jmp	A08_new_optimalization

cant_optimize_002_L1:
	call	bitreq_02
	lea	ecx,[rax+rax*8]		; how much bits for pack without pack
					; this is not right way, some bits may be packed
					; in 7 bits instead of 9 bits
	cmp	ecx,edx
	jbe	pack_1_byte_look_better

	xchg	[last_delta],rbx
	push	rbx
	push	rax
	push	rsi
	add	rsi,rax
	stc
	cmp	[konyc_dat],rsi
	jz	chumaj
	inc	rsi
	cmp	[konyc_dat],rsi
	jz	chumaj
	call	scan002
	call	scanincd
chumaj:	pop	rsi
	pop	rax
	pop	rbx
	xchg	[last_delta],rbx
	jnc	cant_optimize_002_L0

skus_toto_L0:
	push	rbx
	push	rax
	inc	rsi
	call	scan002
	call	scanincd
	dec	rsi		; DEC doesn't change Carry !!!
	xchg	ecx,eax		; number of bytes to ECX
		    		; XCHG doesn't change Carry !!!
	pop	rax		; POP doesn't change Carry !!!
	pop	rbx
	jc	try_next_optimalization
; use chain without change delta require less bits for pack ?
	call	bitreq_02
	push	rdx		; number of bits for pack non-optimized chain
	xchg	ecx,eax		; number of bytes of non-optimized chain -> ECX
				; number of bytes of chain without change delta -> EAX
	push	rbx
	mov	rbx,[last_delta]	; make RBX = RBX in last pack_02
	call	bitreq_02	; return EDX = number of bits for pack chain without change delta
	pop	rbx

	push	rdx
	push	rax
	xor	eax,eax		; simulate pack 1 byte first ( before chain without change delta )
	call	bitreq_02
	pop	rax
	add	[rsp+8*0],rdx
	pop	rdx
	xchg	ecx,eax		; restore EAX = number of bytes of non-optimized chain
	inc	ecx		; number of bytes for pack optimized chain
	cmp	eax,ecx
	pop	rcx		; number of bits for pack non-optimized chain
	jc	pack_1_byte_look_better
	cmp	edx,ecx
	jc	pack_1_byte_look_better

try_next_optimalization:

	cmp	eax,3
	jc	try_old_optimalization
	push	rbx
	push	rax
	inc	rsi
	inc	rsi
	call	scan002
	call	scanincd
	dec	rsi
	dec	rsi
	xchg	ecx,eax		; number of bytes to ECX
		    		; XCHG doesn't change Carry !!!
	pop	rax		; POP doesn't change Carry !!!
	pop	rbx
	jc	try_old_optimalization
; does using of chain without change delta require less bits for pack ?
	call	bitreq_02
	push	rdx		; number of bits for pack non-optimized chain
	xchg	ecx,eax		; number of bytes of non-optimized chain -> CX
			; number of bytes of chain without change delta -> AX
	push	rbx
	mov	rbx,[last_delta]	; make RBX = RBX in last pack_02
	call	bitreq_02	; return EDX = number of bits for pack chain without change delta
	pop	rbx

	push	rdx
	push	rax
	xor	eax,eax		; simulate pack 1 byte first ( before chain without change delta )
	call	bitreq_02
	pop	rax
	add	[rsp+8*0],rdx
	pop	rdx
	xchg	ecx,eax		; restore EAX = number of bytes of non-optimized chain
	inc	ecx
	inc	ecx		; number of bytes for pack optimized chain
	cmp	eax,ecx
	pop	rcx		; number of bits for pack non-optimized chain
	jc	pack_1_byte_look_better
	cmp	edx,ecx
	jc	pack_1_byte_look_better

try_old_optimalization:
	push	rsi
	add	rsi,rax
	cmp	[konyc_dat],rsi
	pop	rsi
	jz	L_NO_0

	call	bitreq_02

	push	rbx
	push	rax
	push	rdx
	push	rax

	push	rsi
	add	rsi,rax
	call	scan002
	call	bitreq_02
	pop	rsi
	add	[rsp+8*0],rax
	add	[rsp+8*1],rdx

	xor	eax,eax
	call	bitreq_02
	push	rdx
	inc	rsi
	call	scan002
	call	bitreq_02
	dec	rsi
	add	[rsp+8*0],rdx
	pop	rdx		; RDX=bits required by pack 1 byte first
	inc	eax		; EAX=bytes packed in 2 steps , pack 1 byte first

	cmp	[rsp+8*0],rax
	jc	obnov_to
;;;	clc
	jnz	obnov_to
	cmp	rdx,[rsp+8*1]
obnov_to:
	pop	rax
	pop	rdx
	pop	rax
	pop	rbx
	jc	pack_1_byte_look_better

A08_new_optimalization:
	cmp	eax,3
	jc	can_t_use_new_optimalization_08
	push	rsi
	lea	rsi,[rsi+rax*1+3]
				; it's very unhappy idea: fucking near the death
				; this isn't usefull for try code marked
				; DANGEROUS for last 3 bytes because this can be
				; unstable (data in in_buf overleap)
	cmp	[konyc_dat],rsi
	pop	rsi
	jbe	this_is_it
	xchg	[last_delta],rbx
	push	rbx
	push	rax
	push	rsi
	lea	rsi,[rsi+rax*1+1]; DANGEROUS , RSI+RAX+1
	call	scan002
	call	scanincd	; DANGEROUS , must be RSI + 1 + RAX (where RAX > 1)
	pop	rsi		; DEC instruction don't change Carry (=CF) !!!
	pop	rax		; POP instruction don't change Carry (=CF) !!!
	pop	rbx
	xchg	[last_delta],rbx	; XCHG instruction doesn't change Carry (=CF) !!!
	jnc	can_t_use_new_optimalization_08

this_is_it:
	push	rbx
	push	rax
	push	rdx		; bits count, but will be overwritten at the first pass
				; because chain > 0 bytes will be found
	push	0		; chain lenght counter

new_optimalization_08_L0:
	call	scan_lim		; scan EAX chain lenght, return min. EBX
	call	scanincd
	jc	new_optimalization_08_L1
	mov	rbx,[last_delta]
new_optimalization_08_L1:
	call	bitreq_02
	push	rdx
	push	rax
	push	rsi
	xchg	[last_delta],rbx
	push	rbx
	add	rsi,rax
	call	scan002
	call	bitreq_02
	pop	rbx
	xchg	[last_delta],rbx
	pop	rsi
	add	rax,[rsp+8*0]
	xchg	ecx,eax
	pop	rax
	add	[rsp+8*0],rdx
	pop	rdx
	cmp	[rsp+8*0],rcx
	jc	toto_bude_asy_lepseeeee
	jnz	toto_bude_asy_horse
	cmp	[rsp+8*1],rdx
	jbe	toto_bude_asy_horse

toto_bude_asy_lepseeeee:
	add	rsp,8*4
	push	rbx
	push	rax
	push	rdx
	push	rcx
toto_bude_asy_horse:

	dec	eax
	cmp	eax,1
	jnz	new_optimalization_08_L0

	pop	rax
	pop	rax
	pop	rax
	pop	rbx
can_t_use_new_optimalization_08:

L_NO_0:

	cmp	eax,9		; under 32 bit opcodes it's enough  for 1 MB
				; data block
				; 16 bit delta is less than 64 kB and require
				; max. 4 bytes for calculate it
				; Summa: Under DOS its enough use CMP AX,4
				;        because small value is fast algorithm
				;        Under 32 bit OS ( Linux, NT 4.0 ) use
				;        big value if big data block
				;        9 is enough for 4 GB of data block
				;        Who can produce 4 GB of ASM code ???
	jnc	cant_optimize_002_L0
; i have chain with AX <2,0Fh> and try pack 1 byte AX times
	push	rax
	push	0		; bits require counter
	push	rax		; pack 1 byte AX times
optimize_002_L2:
	xor	eax,eax
	call	bitreq_02	; include procedure in bitreq02.inc
	inc	rsi
	add	[rsp+8*1],rdx	; bits require counter
	dec	qword [rsp+8*0]	; pack 1 byte EAX times
	jnz	optimize_002_L2	; simulate pack 1 byte EAX times
	pop	rax		; remove word from stack only
	pop	rcx		; ECX = required bits count for pack 1 byte EAX times
	pop	rax		; restore EAX
	sub	rsi,rax		; restore RSI

	call	bitreq_02	; explore once-pack EAX bytes RBX delta bits count
				; return EDX=bits required
	cmp	edx,ecx
	jc	cant_optimize_002_L0
; use JC for prefer pack 1 byte EAX times
; use JBE for prefer once-pack EAX bytes with delta = RBX
; JC is sometimes better because pack 1 byte don't change delta and it's
; possibility pack without change delta ( call scanincd ) later
; JC has better ratio in my experiments by aprox 1 byte per 1 kB of data but
; this depend on data structure and sometimes JBE can be more rational if change
; delta and later pack with this new delta without change delta

; O.K. pack 1 byte now
pack_1_byte_look_better:
	xor	eax,eax
; now will be packed last 1 byte by call pack002 in a00.asm
; EAX=0

cant_optimize_002_L0:
