; input  : EAX = number of bytes for pack request
;          EBX = shift = delta ( if EAX = 2 or more )
; output : EDX = number of bits required for pack
; destroy: nothing

bitreq_02:
	cmp	eax,1
	jnbe	bitreq_more_bytes

bitreq_1_byte:

	push	7	; push doubleword 7
	pop	rdx	; make EDX=7

; scan if can be used 7 bits for pack 1 byte = 00h or 1 byte with shift < 16
; if this can't be used , pack by use 9 bits can be always used

; byte for compress is = 00h ?
	cmp	byte [rsi],0
	jz	bitreq_7_bits	; 7 bits required ( sequence 1100000 )

bitreq_jak_skusas_co_skusas:
; byte isn't = 00h but explore if found equal byte with shift < 16
	push	rax
	mov	al,byte [rsi]
	push	rcx
	push	15
	pop	rcx
	push	rdi
	lea	rdi,[rsi]
	sub	rdi,rcx
	push	r9
	lea	r9,[in_buf]
	cmp	rdi,r9
	jnc	bitreq_pome_skusat
	lea	rdi,[r9]
	lea	rcx,[rsi]
	sub	rcx,rdi
bitreq_pome_skusat:
	pop	r9
	repnz scasb
	pop	rdi
	pop	rcx
	pop	rax
	jz	bitreq_7_bits

; always can be used this mode but has bad pack ratio
; pack 1 byte , use 9 bits ( 1 byte + 1 bit )
	mov	dl,9
bitreq_7_bits:
	mov	al,1		; 1 byte packed EAX=1
	ret


bitreq_more_bytes:
	cmp	rbx,[last_delta]
	jnz	bitreq_another_delta

bitreq_old_delta:
	bsr	edx,eax		; ( bits / 2 ) for calculate bytes count
	lea	edx,[2*rdx+4]	; 4 bits sequence 1000 don't calculate new delta
	ret

bitreq_another_delta:
	cmp	ebx,7Fh
	jnbe	bitreq_big_delta_or_more_bytes
	cmp	eax,4
	jnc	bitreq_big_delta_or_more_bytes

; pack 2 or 3 bytes with delta <+0001h,+007Fh>
	push	8+3
	pop	rdx	;mov	edx,8+3			; 8 bit = 1 byte for MOV BL,[RSI]  INC RSI
	ret				; 3 bit sequence 111 switch to this mode

bitreq_big_delta_or_more_bytes:
; pack 4 or more bytes with delta <+0001h,maximal_delta)
; pack 2 or more bytes with delta <+0080h,maximal_delta)
	push	rax
	push	rbx

	cmp	ebx,7Fh
	jnbe	bitreq_high_delta
	dec	eax
	dec	eax		; invert for 2x INC ECX in decompress

bitreq_high_delta:
	bsr	eax,eax		; (bits/2)  for calculate count

	shr	ebx,8		; remove BL part of delta
	inc	ebx
	inc	ebx
	inc	ebx		; invert for 3x DEC EBX in decompress
	bsr	ebx,ebx		; (bits/2) for calculate delta without BL

	add	eax,ebx
	lea	edx,[2*rax+2+8]	; 2 bit sequence for switch to this mode
				; 8 bit=1 byte for MOV BL,[RSI]   INC RSI
	pop	rbx
	pop	rax
	ret
