; input :  EAX = number of bytes for pack request
;          RBX = shift = delta ( if EAX = 2 or more )
; output : EAX = number of bytes packed

pack002:
	cmp	eax,1
	jnbe	pack_more_bytes

pack_1_byte:

; scan if can be used 7 bits for pack 1 byte = 00h or 1 byte with shift < 16
; if this can't be used , pack by use 9 bits can be always used

; byte for compress is = 00h ?
	mov	al,byte [rsi]
	or	al,al
	jz	common_7_bits	; putbit sequence 1100000

jak_skusas_co_skusas:
; byte isn't = 00h but explore if found equal byte with shift < 16
	push	15
	pop	rcx
	push	rdi
	lea	rdi,[rsi]
	sub	rdi,rcx
	push	r9
	lea	r9,[in_buf]
	cmp	rdi,r9
	jnc	pome_skusat
	lea	rdi,[r9]
	lea	rcx,[rsi]
	sub	rcx,rdi
pome_skusat:
	pop	r9
	repnz scasb
	pop	rdi
	jnz	jerk_it_off_and_try_again
	xchg	ecx,eax
	inc	eax		; EAX = shift (possitive value)

common_7_bits:

	call	putbit1
	call	putbit1
	call	putbit0
	mov	cl,4
	shl	al,cl
pbimu7:	shl	al,1
	call	putbit
	loop	pbimu7

	jmp	pack_1_byte_common_end

jerk_it_off_and_try_again:
; always can be used this mode but has bad pack ratio
; pack 1 byte , use 9 bits ( 1 byte + 1 bit )
	movsb
	dec	rsi		; restore RSI to RSI before pack
	call	putbit0

pack_1_byte_common_end:

	xor	eax,eax
	inc	eax		; 1 byte packed EAX=1

	ret

;

pack_more_bytes:

	push	rax		; store EAX for restore number of bytes packed
				; ( by POP EAX )
	cmp	rbx,[last_delta]
	jnz	another_delta

pack_with_old_delta:
	call	putbit1
	call	putbit0
	call	putbit0
	call	putbit0		; sequence 1000 don't calculate new delta

	mov	ecx,32
fdcd:	dec	ecx
	shl	eax,1
	jnc	fdcd		; shift bits left and remove highest bit=1
				; this bit will be put by INC CX in decompress
mocd:	shl	eax,1
	call	putbit
	dec	ecx
	jz	mwocd
	call	putbit1
	jmp	mocd
mwocd:	call	putbit0
	pop	rax		; packed EAX bytes from input buffer
	ret

another_delta:
	mov	[last_delta],rbx	; all modes change last_delta
;	cmp	ebx,80h			; cmp ebx,80h requires 6 bytes
;	jnc	big_delta_or_more_bytes
	cmp	ebx,7Fh
	jnbe	big_delta_or_more_bytes
	cmp	eax,4
	jnc	big_delta_or_more_bytes

; pack 2 or 3 bytes with delta <+0001h,+007Fh>
	call	putbit1
	call	putbit1			; bit sequence 111 switch to this mode
					; third bit 1 will be passed at end of
					; packing before POP AX
	sub	al,3			; value 2 -> CF=1, value 3 -> CF=0
	adc	bl,bl
	xchg	ebx,eax
	stosb
	call	putbit1			; put last control bit must be after
					; STOSB (for mov bl,[rsi] , inc rsi)
					; because when decompress , bits are
					; processed first and byte second ->
					; when compressing , byte must be
					; processed before last bit
	pop     rax			; value 2 or 3
					;      -> this mode process 2 or 3 bytes
	ret

big_delta_or_more_bytes:
; pack 4 or more bytes with delta <+0001h,maximal_delta)
; pack 2 or more bytes with delta <+0080h,maximal_delta)
	call	putbit1
	call	putbit0

	cmp	ebx,7Fh
	jnbe	high_delta
	dec	eax
	dec	eax			; invert for 2x INC ECX in decompress
high_delta:

	push	rax
	xchg	ebx,eax
	push	rax		; push only for part in BL moved to AL
	shr	eax,8		; this destroy AL
	inc	eax
	inc	eax
	inc	eax		; invert for 3x DEC RBX

	mov	ecx,32
fgfaad:	dec	ecx
	shl	eax,1
	jnc	fgfaad

wetryw:	shl	eax,1
	call	putbit
	dec	ecx
	jz	shsdwd
	call	putbit1
	jmp	wetryw
shsdwd:	call	putbit0
	pop	rbx		; pop only for BL
	pop	rax		; pop bytes count

calculate_count:
	mov	ecx,32
fcdcd:	dec	ecx
	shl	eax,1
	jnc	fcdcd		; shift all bits left and remove highest bit=1
				; this bit will be put by INC CX in decompress
mwocdl:	shl	eax,1
	call	putbit
	dec	ecx
	jz	mwocdt
	call	putbit1
	jmp	mwocdl
mwocdt:
	xchg	ebx,eax
	stosb			; store AL (BL in decompress)
				; as well in delta <+0001h,+007Fh> , stored byte
				; must be before store last bit because
				; when decompress, bit will be processed
				; first and byte will be loaded later

	call	putbit0		; this bit will be processed in
				; decompress for calculate CX ( JC U05 )

	pop	rax		; packed EAX bytes from input buffer
	ret
